require 'globals'
require 'rename_etc'


-- GUI立ち上げ用関数
function GUI ()
  remove_vb_notify()
  remove_window_notify()
  local upd_lst =
  function()
    note_column2sample_info_lst ={}
    local max = #(renoise.song().instruments)
    for i = 1,max do
      update_sample_etc_lst (i)
    end
  end
  upd_lst()

-- Notifierの、link_vb_to_globals ()を参照

  -- Name
  local info1_txt =
  vb:text {
    text = "Name:",
    font = "Big"
  }
  local info1 =
  vb:text {
    id = "id_info1",
    text = " ",
    font = "Big"
  }
  
  -- Value
  local info2_txt =
  vb:text {
    text = "Value:",
    font = "Big"
  }  
  local info2 =
  vb:text {
    id = "id_info2",
    text = " ",
    font = "Big"
  }

  -- Line.Delay
  local info3_txt =
  vb:text {
    text = "→  Line.Delay:",
    font = "Big"
  }  
  local info3 =
  vb:text {
    id = "id_info3",
    text = " ",
    font = "Big"
  }

  -- Minus TrackDelay Option
  local op1_txt =
  vb:text {
    text = "  -TrackDelay:",
    font = "Normal"
  }
  local option1 =
  vb:checkbox {
    value = track_delay_option,
    notifier = function(bool)
      track_delay_option = bool
    end,
  }
  
  -- Plus ColumnDelay Option
  local op2_txt =
  vb:text {
    text = "  +ColumnDelay:",
    font = "Normal"
  }
  local option2 =
  vb:checkbox {
    value = delay_val_option,
    notifier = function(bool)
      delay_val_option = bool
    end,
  }

  -- Volume Option
  local vol_op_txt =
  vb:text {
    text = " Regard Vol as 7F:",
    font = "Normal"
  }
  local vol_op =
  vb:checkbox {
    value = delay_val_option,
    notifier = function(bool)
      volume_option = bool
    end,
  }
  
  -- AllowRename Option
  local op3_txt =
  vb:text {
    text = "  AllowRename:",
    font = "Normal"
  }
  local option3 =
  vb:checkbox {
    value = rename_option,
    notifier = function(bool)
      rename_option = bool
    end,
  }
  
  -- To Sample Editor
  local to_smpl_edtr =
  vb:button {
    text = "To SampleEditor",
    pressed =
    function()
      to_sample_editor(instrument_idx,sample_idx)
    end
  }
  -- Back To Pattern Editor
  local back =
  vb:button {
    text = "Back to Pattern",
    pressed =
    function()
      to_pattern_editor()
    end
  }

  -- Update sample infomation List
  local update_lst =
  vb:button {
    text = "Update List",
    pressed =
    function()
      upd_lst()
    end
  }


  
  -- Rename SampleName With Value and Tags
  local rename_with =
  vb:button {
    text = "Rename with Tags",
    pressed =
    function()
      if type(instrument_idx) =='number' and
        type(sample_idx) =='number' and
        renoise.song().selected_sample.sample_buffer.has_sample_data
        == true
      then
        renoise.song().selected_instrument_index = instrument_idx
        renoise.song().selected_sample_index = sample_idx
        rename_selected_sample_with_tags (
          val_from_selection_start,tags[1],tags[2])
      else end
    end
  }

  -- Remove Tags and Value from SampleName
  local remove_tags =
  vb:button {
    text = "Remove Tags",
    pressed =
    function()
      if type(instrument_idx) =='number' and
        type(sample_idx) =='number'
      then
        renoise.song().selected_instrument_index = instrument_idx
        renoise.song().selected_sample_index = sample_idx
        remove_tags_from_selected_sample (tags[1],tags[2])
      else end
    end
  }

  -- Tag1 for Renaming and Getting Values
  local tag1 =
  vb:textfield {
    text = tags[1],
    notifier = function(s)
      tags[1]=s
    end
  }

  -- Tag2 for Renaming and Getting Values
  local tag2 =
  vb:textfield {
    text = tags[2],
    notifier = function(s)
      tags[2]=s
    end
  }

  -- Value field for Renaming 
  local val_from =
  vb:textfield {
    id = "id_val_from_selection_start",
    text = tostring(val_from_selection_start),
    notifier = function(s)
      val_from_selection_start = tonumber(s)
    end
  }

  -- Link renaming value to SelectionStart
  local link_s =
  vb:button {
    text = "Link Selection Start",
    pressed =
    function()
      remove_notifi_selection ()
      add_notifi_selection ()
    end
  }
  
  -- Unlink SelectionStartPoint
  local unlink_s =
  vb:button {
    text = "Unlink",
    pressed =
    function()
      remove_notifi_selection ()
    end
  }

  -- Nudge A Note
  local nudge_it =
  vb:button {
    text = "NudgeIt",
    pressed =
    function()
      nudge_plus()
    end
  }
  
  -- Minus Nudge
  local minus_nudge =
  vb:button {
    text = "- Nudge",
    pressed =
    function()
      nudge_minus()
    end
  }
  -- PatternTrack Nudge
  local pt_nudge =
  vb:button {
    text = "Nudge PatternTrack",
    pressed =
    function()
      nudge_pattern_track ()
    end
  }
  -- Minus PatternTrack Nudge
  local minus_pt_nudge =
  vb:button {
    text = "- Nudge PatternTrack",
    pressed =
    function()
      minus_nudge_pattern_track ()
    end
  }

  -- With EffectColumn Option
  local op4_txt =
  vb:text {
    text = "    With EffectColumn:",
    font = "Normal"
  }
  local option4 =
  vb:checkbox {
    value = nudge_effect_option,
    notifier = function(bool)
      nudge_effect_option = bool
    end,
  }

  -- Undo
  local undo =
  vb:button {
    text = "undo",
    pressed =
    function()
      undo()
    end
  }

  
  -- spacingっていくつあっても最後の一回のしか効かないのね。当たり前だ…。
  local s0,s1,s1_1,s2,s2_1,s2_2,s2_3,s2_4,s2_5,s3,s4_1,s4_2,s4,s3s4,s5_1,s5_1_1,s5_2,s5

  s1_1 = vb:row{info1_txt,info1,spacing=3}
  s1 = vb:row{s1_1,spacing=10,to_smpl_edtr,back,update_lst}
  s2_1 = vb:row{info2_txt,info2,spacing=3}
  s2_2 = vb:row{info3_txt,info3,spacing=3}
  s2_3 = vb:row{op1_txt,option1,spacing=3}
  s2_4 = vb:row{op2_txt,option2,spacing=3}
  s2_5 = vb:row{vol_op_txt,vol_op,spacing=3}  
  s2 = vb:row{s2_1,s2_2,s2_3,s2_4,s2_5,spacing=10}
  s3 = vb:row{tag1,val_from,tag2,link_s,unlink_s,spacing=10,}
  s4_1 = vb:row{rename_with,spacing=10,remove_tags,}
  s4_2 = vb:row{op3_txt,option3,spacing=3}
  s4 = vb:row{s4_1,s4_2,spacing=10}
  -- S3 + S4
  s3s4 = vb:column{s3,s4,spacing =10,style ='group',margin =5}
  
  s5_1 = vb:column{nudge_it,minus_nudge,spacing=10}
  s5_1_1 = vb:column{pt_nudge,minus_pt_nudge,spacing=10}  
  
  -- With EffectColumn Option
  s5_2 = vb:row{op4_txt,option4,spacing=3}
  
  s5 = vb:row{s5_1,s5_1_1,undo,s5_2,spacing=10,style ='group',margin =5}
  s0 = vb:column{s1,s2,s3s4,s5,spacing=10,margin = 10}
  -- 表示。
  renoise.app():show_custom_dialog("Tagging Nudging" ,s0)
  
  -- notifierを起動させる。
  add_window_notify()
  link_active_window ()
  add_vb_notify()
end


-- menu entries登録。 
      
renoise.tool():add_menu_entry {
   name = "Pattern Editor:Tagging Nudging...",
   invoke = function() GUI() end
}

